# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

* [`fail2ban_exporter`](#fail2ban_exporter): This module manages Fail2ban Exporter
* [`fail2ban_exporter::install`](#fail2ban_exporterinstall): This class install Fail2ban exporter requirements and binaries.
* [`fail2ban_exporter::service`](#fail2ban_exporterservice): This class manages service

## Classes

### fail2ban_exporter

Init class of Fail2ban Exporter module. It can installes Fail2ban Exporter binaries and single Service.

#### Examples

##### 

```puppet
include fail2ban_exporter
```

#### Parameters

The following parameters are available in the `fail2ban_exporter` class.

##### `version`

Data type: `String`

Fail2ban exporter release. See https://github.com/anclrii/Fail2ban-Exporter/releases

Default value: 'master'

##### `base_dir`

Data type: `Stdlib::Absolutepath`

Base directory where Fail2ban is extracted.

Default value: '/opt'

##### `bin_dir`

Data type: `Stdlib::Absolutepath`

Directory where binaries are located.

Default value: '/usr/local/bin'

##### `base_url`

Data type: `Stdlib::HTTPUrl`

Base URL for Fail2ban Exporter.

Default value: 'https://github.com/Kylapaallikko/fail2ban_exporter/archive'

##### `download_extension`

Data type: `String`

Extension of Fail2ban exporter binaries archive.

Default value: 'tar.gz'

##### `download_url`

Data type: `Optional[Stdlib::HTTPUrl]`

Complete URL corresponding to the Fail2ban exporter release, default to undef.

Default value: `undef`

##### `extract_command`

Data type: `Optional[String]`

Custom command passed to the archive resource to extract the downloaded archive.

Default value: `undef`

##### `manage_user`

Data type: `Boolean`

Whether to create user for fail2ban-exporter or rely on external code for that.

Default value: `false`

##### `manage_group`

Data type: `Boolean`

Whether to create user for fail2ban-exporter or rely on external code for that.

Default value: `false`

##### `user`

Data type: `String`

User running fail2ban-exporter.

Default value: 'root'

##### `group`

Data type: `String`

Group under which fail2ban-exporter is running.

Default value: 'root'

##### `user_shell`

Data type: `Stdlib::Absolutepath`

if requested, we create a user for fail2ban-exporter. The default shell is false. It can be overwritten to any valid path.

Default value: '/bin/false'

##### `extra_groups`

Data type: `Array[String]`

Add other groups to the managed user.

Default value: []

##### `service_ensure`

Data type: `Variant[Stdlib::Ensure::Service, Enum['absent']]`

State ensured from fail2ban-exporter service.

Default value: 'running'

##### `listen_address`

Data type: `Stdlib::Host`

Fail2ban exporter listen address.

Default value: '0.0.0.0'

##### `listen_port`

Data type: `Stdlib::Port`

Fail2ban exporter listen port (required to be accessible).

Default value: 9180

##### `manage_python`

Data type: `Boolean`

Whether to install python3 or rely on external code for that.
Python3 is required to run exporter binary.

Default value: `true`

##### `python_required_packages`

Data type: `Array[String]`

Python required package list.

Default value: ['prometheus_client']

### fail2ban_exporter::install

This class install Fail2ban exporter requirements and binaries.

#### Examples

##### 

```puppet
include fail2ban_exporter::install
```

#### Parameters

The following parameters are available in the `fail2ban_exporter::install` class.

##### `version`

Data type: `String`

Fail2ban exporter release. See https://github.com/anclrii/Fail2ban-Exporter/releases

Default value: $fail2ban_exporter::version

##### `base_dir`

Data type: `Stdlib::Absolutepath`

Base directory where Fail2ban is extracted.

Default value: $fail2ban_exporter::base_dir

##### `bin_dir`

Data type: `Stdlib::Absolutepath`

Directory where binaries are located.

Default value: $fail2ban_exporter::bin_dir

##### `download_extension`

Data type: `String`

Extension of Fail2ban exporter binaries archive.

Default value: $fail2ban_exporter::download_extension

##### `download_url`

Data type: `Stdlib::HTTPUrl`

Complete URL corresponding to the Fail2ban exporter release, default to undef.

Default value: $fail2ban_exporter::real_download_url

##### `extract_command`

Data type: `Optional[String]`

Custom command passed to the archive resource to extract the downloaded archive.

Default value: $fail2ban_exporter::extract_command

##### `manage_user`

Data type: `Boolean`

Whether to create user for fail2ban-exporter or rely on external code for that.

Default value: $fail2ban_exporter::manage_user

##### `manage_group`

Data type: `Boolean`

Whether to create user for fail2ban-exporter or rely on external code for that.

Default value: $fail2ban_exporter::manage_group

##### `user`

Data type: `String`

User running fail2ban-exporter.

Default value: $fail2ban_exporter::user

##### `group`

Data type: `String`

Group under which fail2ban-exporter is running.

Default value: $fail2ban_exporter::group

##### `user_shell`

Data type: `Stdlib::Absolutepath`

if requested, we create a user for fail2ban-exporter. The default shell is false. It can be overwritten to any valid path.

Default value: $fail2ban_exporter::user_shell

##### `extra_groups`

Data type: `Array[String]`

Add other groups to the managed user.

Default value: $fail2ban_exporter::extra_groups

##### `python_required_packages`

Data type: `Array[String]`

Python required package list.

Default value: $fail2ban_exporter::python_required_packages

### fail2ban_exporter::service

This class manages service

#### Examples

##### 

```puppet
include fail2ban_exporter::service
```

#### Parameters

The following parameters are available in the `fail2ban_exporter::service` class.

##### `ensure`

Data type: `Variant[Stdlib::Ensure::Service, Enum['absent']]`

State ensured from fail2ban-exporter service.

Default value: $fail2ban_exporter::service_ensure

##### `user`

Data type: `String`

User running fail2ban-exporter.

Default value: $fail2ban_exporter::user

##### `group`

Data type: `String`

Group under which fail2ban-exporter is running.

Default value: $fail2ban_exporter::group

##### `port`

Fail2ban exporter port (required to be accessible).

##### `fail2ban_host_address`

Fail2ban host address.

##### `fail2ban_api_port`

Fail2ban api port.

##### `bin_dir`

Data type: `Stdlib::Absolutepath`

Directory where binaries are located.

Default value: $fail2ban_exporter::bin_dir

##### `listen_address`

Data type: `Stdlib::Host`



Default value: $fail2ban_exporter::listen_address

##### `listen_port`

Data type: `Stdlib::Port`



Default value: $fail2ban_exporter::listen_port

